## ceres-solver 2.1.0+dfsg

=== debian/changelog ===
ceres-solver (2.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Update patches for new version
  * Fix Sphinx theme not found
  * Update debian/copyright
  * Remove unused lintian override

 -- Francois Mazen <francois@mzf.fr>  Sun, 10 Apr 2022 00:21:07 +0200
