## ceres-solver 2.1.0+really2.0.0+dfsg1

=== debian/changelog ===
ceres-solver (2.1.0+really2.0.0+dfsg1-2) unstable; urgency=medium

  * Team upload
  * Explicitly requiring to build the tests with the shared lib
  * Removing duplicate line in d/copyright

 -- Pierre Gruet <pgt@debian.org>  Tue, 07 Jun 2022 15:22:34 +0200

ceres-solver (2.1.0+really2.0.0+dfsg1-1) unstable; urgency=medium

  * Team upload
  * New upstream version 2.1.0+really2.0.0+dfsg1 (Closes: #1012419)
  * Refreshing patches
  * Back to former install and docs paths
  * Fixing unneeded versioned dependencies in d/control
  * Building and running the tests only when building the shared library,
    so that they are not run twice.
  * Honouring DEB_BUILD_OPTIONS=nocheck

  [ Francois Mazen ]
  * Bump standard version to 4.6.1.0
  * Add Multi-Arch fields in debian/control
  * Update copyright date
  * Adding a patch to fix i386 failing tests with version 2.1.0+dfsg

 -- Pierre Gruet <pgt@debian.org>  Tue, 07 Jun 2022 14:04:12 +0200
